diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/defs.h linux-openmosix/include/hpc/defs.h
--- linux/include/hpc/defs.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/defs.h	2004-02-05 02:48:29.000000000 +0100
@@ -0,0 +1,121 @@
+/* All changes since  Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+/* all manners of independent variables and definitions required by the
+ * MOSIX package and possibly also by the MOSIX module itself:
+ */
+
+#ifndef _MOS_DEFS_H
+#define _MOS_DEFS_H
+
+extern int mosix_running;
+extern int active_cpus;
+
+extern spinlock_t whereto_lock;
+
+extern struct task_struct *mig_proc;
+extern int mig_daemon_active;
+extern struct task_struct *info_proc;
+extern int info_daemon_active;
+
+extern int slow_alpha, fast_alpha;	/* units over DECAY_QUOTIENT */
+extern int decay_interval;	/* in seconds */
+extern int mosadmin_gateways;	/* number of network segments (gateways) */
+extern int mosadmin_mode_stay;	/* no automatic migration out */
+extern int mosadmin_mode_lstay;	/* same just for local processes */
+extern int mosadmin_mode_block;	/* do not accept guests */
+extern int mosadmin_mode_quiet;	/* stop the load-chat (obsolete) */
+extern int mosadmin_mode_nomfs;	/* disallow MFS access to this node */
+extern char bootexpel, expel_progress;
+extern int latest_free_mem;
+
+extern struct task_struct *chosen_for_balance;
+extern struct task_struct *chosen_for_mdp;
+
+#define	STD_SPD		15000	  /* speed units of a standard processor */
+extern int cpuspeed;		  /* this node's relative processor speed */
+extern int standard_speed;	  /* if sysadmin changes standard-processor */
+extern int PE;			/* MOSIX number for this processor */
+extern int NPE;			/* number of configured MOSIX nodes */
+extern int MAXPE;		/* maximum MOSIX number in the cluster */
+
+#ifdef CONFIG_MOSIX_TOPOLOGY
+#if CONFIG_MOSIX_MAXTOPOLOGY > 10
+#warning MAXIMUM TOPOLOGY too big -- truncated to 10
+#define	MAX_MOSIX_TOPOLOGY	10
+#elif CONFIG_MOSIX_MAXTOPOLOGY < 2
+#warning MAXIMUM TOPOLOGY < 2 -- so why use it at all?
+#define	MAX_MOSIX_TOPOLOGY	1
+#else
+#define	MAX_MOSIX_TOPOLOGY	CONFIG_MOSIX_MAXTOPOLOGY
+#endif /* CONFIG_MOSIX_MAXTOPOLOGY */
+#else
+#define	MAX_MOSIX_TOPOLOGY	1
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+
+extern struct mosix_cost
+{
+	int PAGE_D, PAGE_R;
+	int SYSCALL_D, SYSCALL_R;
+	int COPYOUT_BASE_D, COPYOUT_PER_KB_D;
+	int COPYOUT_BASE_R, COPYOUT_PER_KB_R;
+	int COPYIN_BASE_D, COPYIN_PER_KB_D;
+	int COPYIN_BASE_R, COPYIN_PER_KB_R;
+	int MIGRATION_BASIC, MIGRATION_PER_PAGE;
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	int first, last;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+} mosix_cost[MAX_MOSIX_TOPOLOGY];
+
+extern struct mfs_cost
+{
+	int MFS_CONN_S, MFS_CONN_C;
+	int MFS_INKB_S, MFS_INKB_C;
+	int MFS_OUTKB_S, MFS_OUTKB_C;
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	int first, last;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+} mfs_cost[MAX_MOSIX_TOPOLOGY];
+
+extern struct opcost deputy_here[MAX_MOSIX_TOPOLOGY];
+
+#ifdef CONFIG_MOSIX_FS
+#define	MAX_MFS_STATNODES	10
+
+struct mfs_stats
+{
+	int nnodes;
+	unsigned short hint;
+	unsigned short nodes[MAX_MFS_STATNODES];
+	int64_t conns[MAX_MFS_STATNODES];
+	int64_t inbytes[MAX_MFS_STATNODES];
+	int64_t outbytes[MAX_MFS_STATNODES];
+};
+#else
+#define	MAX_MFS_STATNODES	0
+#endif /* CONFIG_MOSIX_FS */
+
+/* node-disconnection timeout: */
+#define	MOSIX_CONNECTION_KEEPALIVE_INTERVAL	30
+#define	MOSIX_CONNECTION_KEEPALIVE_MAXTRIES	6
+#define	MOSIX_CONNECTION_KEEPALIVE_TOTAL	150 /* changed from 180 */
+
+/* default slow decay brings process-statistics down to 10% in 3 minutes */
+/* default fast decay brings process-statistics down to 10% in 1 minute */
+
+#define	DEFAULT_DECAY_INTERVAL	2		/* seconds */
+#define	DEFAULT_SLOW_ALPHA	(DECAY_QUOTIENT * 975 / 1000)
+#define	DEFAULT_FAST_ALPHA	(DECAY_QUOTIENT * 926 / 1000)
+
+#define	MF	100		/* MOSIX frequency */
+
+#define	MILLION		1000000
+#define	DMILLION	1000000.0
+
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/dfsa.h linux-openmosix/include/hpc/dfsa.h
--- linux/include/hpc/dfsa.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/dfsa.h	2002-10-07 08:29:53.000000000 +0200
@@ -0,0 +1,61 @@
+/* All changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Amnon Shiloh.
+ */
+
+
+#ifndef _MOS_DFSA_H
+#define _MOS_DFSA_H
+
+#include <linux/fs.h>
+#include <linux/file.h>
+#include <linux/mount.h>
+#include <linux/dfsa_interface.h>
+
+#ifdef CONFIG_MOSIX_DFSA
+
+#define	MAXDFSAFS	8
+#define	MAXDFSALINKS	8
+#define	MAXDFSALINKLEN	128
+
+struct dfsatab
+{
+	unsigned short len;
+	char ndefs;
+	struct dfsdef
+	{
+		char defno;	/* mount=1-MAXDFSAFS, symlink>MAXDFSAFS */
+		char mounted;
+		short offset;
+	} dfsdef[0];
+};
+
+/* update flags (dupdates): */
+
+int dfsa_addlink(char *);
+int dfsa_dellink(char *);
+int dfsa_clearlinks(void);
+char *dfsa_showlinks(void);
+void dfsa_adapt(struct dfsatab *);
+int dfsa_sync(int);
+void dfsa_everyone_was_updated(void);
+void clear_dfsasync(void);
+void remote_clear_dfsa(void);
+void dfsa_tinit(void); 
+void deputy_resync_dfsa(void);
+char *deputy_pack_dfsa_changes(int *);
+void remote_unpack_dfsa_changes(char *);
+char *remote_pack_dfsa_changes(int *);
+void deputy_unpack_dfsa_changes(char *);
+void dfsa_check_comm_send(int *, char **, int *);
+void dfsa_comm_recv(int, char *);
+int enter_remote_dfsa_mode(void);
+void leave_remote_dfsa_mode(void);
+void dfsa_exit(void);
+void dfsa_verify(void); /* verify proper VFS registration */
+#endif
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/dscosts.h linux-openmosix/include/hpc/dscosts.h
--- linux/include/hpc/dscosts.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/dscosts.h	2002-06-24 09:22:32.000000000 +0200
@@ -0,0 +1,24 @@
+/* dscosts.h -- MOSIX */
+/* cost of remote operations (microseconds) */
+
+/* measuring date: Mon Apr 30 20:08:13 IDT 2001 */
+/* between two Pentium-III/1GHz over Ethernet-100 */
+
+#define	PAGE_COST_D	81
+#define	PAGE_COST_R	150
+
+#define	SYSCALL_COST_D	39
+#define	SYSCALL_COST_R	38
+
+#define	COPYOUT_COST_BASE_D	0
+#define	COPYOUT_COST_PER_KB_D	11
+#define	COPYOUT_COST_BASE_R	0
+#define	COPYOUT_COST_PER_KB_R	18
+
+#define	COPYIN_COST_BASE_D	0
+#define	COPYIN_COST_PER_KB_D	18
+#define	COPYIN_COST_BASE_R	0
+#define	COPYIN_COST_PER_KB_R	12
+
+#define	MIGRATION_COST_BASIC	8141
+#define	MIGRATION_COST_PER_PAGE	351
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/hpcctl.h linux-openmosix/include/hpc/hpcctl.h
--- linux/include/hpc/hpcctl.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/hpcctl.h	2004-04-06 21:19:41.000000000 +0200
@@ -0,0 +1,83 @@
+/* All changes since Feb 12, 2002 copyright by Moshe Bar 
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Oren Laadan, Amnon Shiloh, Moshe Bar
+ */
+
+#ifndef _MOS_MOSCTL_H
+#define _MOS_MOSCTL_H
+
+#include <linux/types.h>
+
+/*
+ * MOSIX API
+ */
+
+/* migration requests via /proc/nnnnn/goto */
+
+#define DM_GOBACKHOME    0       /* just go back home */
+#define DM_BALANCE       (-1)    /* perform load balancing */
+
+
+/* constants for status report (/proc/mosix/nodes/nnn/status) */
+
+#define	DS_MOSIX_DEF	0x001
+#define DS_MOSIX_UP     0x002
+#define DS_STAY         0x004
+#define DS_LSTAY        0x008
+#define DS_BLOCK        0x010
+#define DS_QUIET        0x020
+#define DS_NOMFS        0x040
+
+
+/* constants for statictics decay */
+
+#define DADV_CPU        1       /* a pure CPU task */
+#define DADV_NOCPU      2       /* a non-computational task */
+#define DADV_NODECAY    3       /* task of a uniform mix of rapid changes */
+#define DADV_SLOWDECAY  4       /* task may change its nature over long run */
+#define DADV_FASTDECAY  5       /* task changes its nature frequently */
+#define DADV_OWNDECAY   6       /* task defined its own decay policy */
+
+#define DADV_POLICY     0x00F   /* policy mask */
+
+#define DADV_CLEAR      0x010   /* clear statistics: nature is changing */
+#define DADV_INHERIT    0x020   /* children of same nature */
+#define DADV_EXEC       0x040   /* maintain advice after exec */
+#define DADV_EXECONCE   0x080   /* maintain advice after only the next exec */
+#define DADV_NOINHERIT  0x100   /* cancel inheritance */
+#define DADV_NOEXEC     0x200   /* cancel advice on exec */
+#define DADV_NOEXECONCE 0x400   /* cancel DADV_EXECONCE */
+#define DADV_ENQUIRE    0x1000  /* enquire decay policy */
+
+#define DADV_DEFAULT    DADV_SLOWDECAY
+
+#define DECAY_QUOTIENT  1000    /* quotient for the "decay" argument */
+
+
+/* load information */
+
+struct mosix_info {
+        unsigned long load;
+	unsigned short speed;
+        unsigned short ncpus;
+        unsigned short util;
+        unsigned short status;
+	int64_t mem;
+	int64_t rmem;
+	int64_t tmem;
+ 	unsigned long load_limit; /* MOSIX_LOADLIMIT */
+ 	unsigned long llimitmode;
+ 	unsigned long loadremote;
+ 	unsigned long loadlocal;
+ 	unsigned long cpu_limit; /* MOSIX_LOADLIMIT */
+ 	unsigned long cpulimitmode;
+ 	unsigned long cpuremote;
+ 	unsigned long cpulocal;
+};
+
+#endif
+/* new proc entries after here */
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/hpctask.h linux-openmosix/include/hpc/hpctask.h
--- linux/include/hpc/hpctask.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/hpctask.h	2004-04-06 21:19:41.000000000 +0200
@@ -0,0 +1,351 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+#ifndef _LINUX_MOSIXTASK_H
+#define _LINUX_MOSIXTASK_H
+
+#include <hpc/defs.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+
+typedef long long now_t;
+#ifdef CONFIG_MOSIX_DFSA
+struct dfsatab;
+#endif /* CONFIG_MOSIX_DFSA */
+
+#ifdef CONFIG_MOSIX_FS
+struct dentry;
+struct mfs_stats;
+#endif /* CONFIG_MOSIX_FS */
+
+struct opcost
+{
+	int page, syscall, out, outkb, in, inkb;
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	int first, last;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+};
+
+struct mosix_task
+{
+	volatile uint32_t dflags;	/* distributed (MOSIX) flags */
+	atomic_t dreqs;			/* bits that others may request */
+	/* following chars/bits should be in dflags, but modified within
+	 * interrupt code... if only the compiler generated single-instruction
+	 * codes for "|=" and "&=~" (but it doesn't) */
+	volatile char commpri;		/* prioririty for MOSIX communication */
+	volatile char ignoreoldsigs;	/* deliberately cleared ->sigpending */
+	volatile char catchme;		/* catch for debugging */
+
+	char hsleep_count;		/* count on DHEAVYSLEEP */
+	volatile int whereto;		/* migration request */
+	int lock_depth;			/* of the mosix_flag */
+	volatile uint32_t stay;		/* reasons why process must stay */
+	struct prequest *prequest;	/* requests to this task */
+	int whereami;			/* where the process is */
+	int deppe;			/* where the process came from */
+	volatile long bstate;		/* backed-up state while in MOSIX */
+	rwlock_t state_lock;		/* changes of bstate */
+	kernel_cap_t remote_caps;	/* effective capabilities on REMOTE */
+	struct held_files
+	{
+		struct file *f;		/* a file in use */
+		char denywrite;		/* whether holding i_writecount down */
+	} *held_files;			/* files held by remote VM */
+	int held_allocated;		/* # of entries in "held_inodes" */
+	struct mosix_link *contact;	/* DEPUTY <==> REMOTE connection */
+	struct task_struct *ancesstor;	/* nearest ancesstor when dependent */
+	uint32_t deputytime;		/* ticks spent on DEPUTY */
+	long last_sigxcpu;		/* last [prof] time SIGXCPU was sent */
+	int64_t passedtime;		/* time already passed to DEPUTY */
+	int64_t uttime;		/* time to add(REMOTE)/subtract(LOCAL) to/from
+				 * times->tms_utime for statistic purposes */
+	int64_t dctime;		/* decayed user-time (ms) */
+	int64_t cutime;		/* cummulative dependent-child user-time (ms) */
+	int64_t pagetime;	/* time waiting for free pages (ms) */
+	int64_t ndemandpages;	/* statistical # of demand pages */
+	int64_t nsyscalls;	/* statistical # of of syscalls */
+	int64_t ncopyouts;	/* statistical # of copying kernel to user */
+	int64_t copyoutbytes;	/* statsitical # of bytes to user */
+	int64_t ncopyins;	/* statistical # of copying user to kernel */
+	int64_t copyinbytes;	/* statistical # of bytes from user */
+	uint32_t iocounter;	/* combintaion of above statistics */
+	struct opcost depcost[MAX_MOSIX_TOPOLOGY]; /* costs on DEPUTY */
+	unsigned long  depspeed;		/* speed of DEPUTY */
+	int64_t last_consider;	/* user time since last considered migration */
+	now_t last_mconsider;	/* when last selected for memory-balancing */
+	unsigned short decsecs;	/* seconds within decay cycle */
+	unsigned short deccycle;/* length of decay cycle in seconds */
+	short decay;		/* decay factor (out of DECAY_QUOTIENT) */
+	unsigned char dpolicy;	/* statistic-collection policy */
+	char disclosure;	/* level of disclosure */
+	uint32_t asig;		/* signals arriving on REMOTE */
+	siginfo_t *forced_sigs;	/* REMOTE forced signals */
+	int nforced_sigs;	/* # of REMOTE forced signals */
+	int pages_i_bring;	/* # if pages still to be brought */
+	int rpagecredit;	/* # of expected remote page-faults */
+	int rfreepages;		/* # of mapped-pages to bring without penalty */
+	int page_allocs;	/* page allocation requests decaying counter */
+	short ran;		/* ticks running during last second */
+	unsigned short runstart;/* "load_ticks" (+1) since running */
+	int nmigs;		/* number of [successful] migrations - ever */
+	int load;		/* estimated contribution to load */
+	int sonpid;		/* pid of son in remote-fork */
+	int loadhere;		/* original local load */
+	int migpages;		/* # of migrating pages */
+	void *inexec;		/* structure while in "exec" */
+	wait_queue_head_t wait_dist;/* misc. wait for process */
+	unsigned long exit_mem;	/* memory on REMOTE when exited */
+	unsigned short deputy_regs; /* bit map of regs in charge of DEPUTY */
+	unsigned short pass_regs; /* bit map of regs to pass */
+	__u32 features[NCAPINTS]; /* CPU features on original node */
+	short mypid;		/* original PID */
+	short sigmig;		/* signal to receive on migration */
+	uint32_t *altregs;	/* place of registers when not on stack-top */
+	/* FIXME: these really needs to go inside altregs */
+	unsigned long altfs; /* fs segment register */
+	unsigned long altgs; /* gs segment register */
+	void *mosix_log;
+	struct data_cache *ucache;
+	char *ps;		/* common "ps" information */
+	struct mask
+	{	int miggroup;
+		int migpolicy;	/* the policy of migration condition */
+		uint32_t mignodes; /* list of nodes */
+	} mask;
+	int memused, memunused, memswapped;	/* memory split-up */
+	struct depinfo
+	{
+		pid_t pgrp;
+		pid_t session;
+		char comm[16];
+		pid_t tgid;
+	} depinfo;
+	unsigned int dirty_bits;	/* hidden bit-args to Linux routines */
+	unsigned int dirty_arg;		/* hidden argument to Linux routines */
+	pid_t sontgid;                  /* son tgid in remote-fork */
+	struct file *dirty_file;
+#ifdef CONFIG_MOSIX_DFSA
+	int copy_ins;
+	int bytes_in;
+	uint32_t dupdates;
+	struct dfsatab *ttab;
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+	int iget_mfs_pe;
+	unsigned long long iget_mfs_handle;
+	int selected;
+	int lastexec;
+	int lastmagic;
+	struct mfs_stats *mfs_stats;
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DIAG
+	int mig_page_count;
+#endif /* CONFIG_MOSIX_DIAG */
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	long last_per_cpu_utime[NR_CPUS];
+	long last_per_cpu_stime[NR_CPUS];
+#endif
+};
+
+#ifdef CONFIG_MOSIX_DFSA
+#define	DFSA_INIT_TASK	/* All fields are 0, nothing to declare */
+#else
+#define DFSA_INIT_TASK
+#endif /* CONFIG_MOSIX_DFSA */
+
+#ifdef CONFIG_MOSIX_FS
+#define	MFS_INIT_TASK	/* All fields are 0, nothing to declare */
+#else
+#define	MFS_INIT_TASK
+#endif /* CONFIG_MOSIX_FS */
+
+#define MASK_INIT_TASK	/* All fields are 0, nothing to declare */
+
+/* only non-zero fields are mentioned: */
+#define MOSIX_INIT_TASK(tsk) mosix: { \
+	dreqs:		ATOMIC_INIT(0),		\
+	lock_depth:  	-1,			\
+	bstate:		TASK_SAME, 		\
+	wait_dist: 	__WAIT_QUEUE_HEAD_INITIALIZER(tsk.mosix.wait_dist), \
+	state_lock:	RW_LOCK_UNLOCKED,	\
+	disclosure:     CONFIG_MOSIX_DISCLOSURE, \
+	MASK_INIT_TASK \
+	DFSA_INIT_TASK \
+	MFS_INIT_TASK \
+}
+
+/*
+ * distributed flags (dflags) that are set only by the process itself,
+ * (but may be read by others):
+ * the following locks (in correct order of locking) are required to
+ * modify those bits:
+ *
+ * DINSCHED:		runqueue_lock
+ * DHEAVYSLEEP:		runqueue_lock
+ * DREMOTEDFSA:		runqueue_lock
+ * DPASSING:		runqueue_lock
+ * DINCOMING:		runqueue_lock
+ * DDEPUTY:		lock_mosix, tasklist_lock, runqueue_lock, task_lock
+ * DFINISHED:		lock_mosix, runqueue_lock, task_lock
+ * DPAGEIN:		runqueue_lock
+ * DSENTURGENT:		runqueue_lock
+ * DFAKESIGNAL:		sometimes sigmask_lock
+ */
+#define DDEPUTY		0x00000001	/* process is a DEPUTY stub */
+#define DREMOTE		0x00000002	/* process is running remotely */
+#define	DINSCHED	0x00000004	/* MOSIX task within "schedule" */
+#define DSYNC		0x00000008	/* remote process is synced and waits */
+#define DPSYNC		DSYNC		/* deputy must tell us to continue */
+#define DNESTED		0x00000010	/* nested requests from remote */
+#define	DSENTURGENT	0x00000020	/* REMOTE has already sent OOB */
+#define DINCOMING	0x00000040	/* process coming here */
+#define DPASSING	0x00000080	/* process is in migration */
+#define DPAGEIN		0x00000100	/* in pagein, considered running */
+#define DFINISHED	0x00000200	/* wants to become zombie */
+#define	DREMOTEDAEMON	0x00000400	/* set DREMOTE on "fork" */
+#define	DFAKESIGNAL	0x00000800	/* produce a fake signal */
+#define	DHEAVYSLEEP	0x00001000	/* prevent signals/events when asleep */
+#define	DTRACESYS1	0x00002000	/* PT_TRACESYS done before syscall */
+#define	DTRACESYS2	0x00004000	/* syscall done before 2nd PT_TRACESYS*/
+#define	DMUSTBEBACK	0x00008000	/* MUST arrive back home */
+#define	DDUMPABLE	0x00010000	/* copy of dumpable when DEPUTY */
+#define	DDELAYHELD	0x00020000	/* rebuild held_files later */
+#define DTDUMPABLE      0x00040000      /* copy of task_dumpable when DEPUTY */
+#define DMIGFILTER	0x00040000	/* process migration is conditioned */
+#ifdef CONFIG_MOSIX_DFSA
+#define	DSTATSDOWN	0x00800000	/* turn off local system-call stats */
+#define	DREMOTEDFSA	0x01000000	/* on REMOTE: within a DFSA syscall */
+#endif /* CONFIG_MOSIX_DFSA */
+
+/*
+ * bits in "dreqs" (anything that others can set):
+ */
+
+#define DREQ_NICECNG		0x00000001	/* priority changed */
+#define	DREQ_UPDOVERHEADS	0x00000002	/* update overheads */
+#define	DREQ_HOMEWAKE		0x00000004	/* wake when arrived home */
+#define	DREQ_CHECKCONF		0x00000008	/* check openMosix configuration */
+#define	DREQ_CHECKSTAY		0x00000010	/* check whether still stay */
+#define	DREQ_URGENT		0x00000020	/* something urgent (R=>D) */
+#define	DREQ_CAPCNG		0x00000040	/* capabilities changed */
+#define	DREQ_INFOCNG		0x00000080	/* disclosed info changed */
+#define	DREQ_FILEUNMAP		0x00000100	/* file(s) were unmapped */
+#ifdef CONFIG_MOSIX_DFSA
+#define	DREQ_NOTUPTODATE	0x10000000	/* send it all again */
+#define	DREQ_DFSASYNC		0x20000000	/* DFSA world changed */
+#define	DREQ_EXITDFSA		0x40000000	/* call DEPUTY ASAP */
+#else
+#define	DREQ_DFSASYNC		0
+#define	DREQ_EXITDFSA		0
+#endif /* CONFIG_MOSIX_DFSA */
+
+#define	tell_process(p,what)	atomic_set_mask(what,&(p)->mosix.dreqs)
+#define	process_ack(p,what)	atomic_clear_mask(what,&((p)->mosix.dreqs))
+#define	process_told(p,what)	(atomic_read(&((p)->mosix.dreqs)) & (what))
+
+/*
+ * reasons to stay:
+ */
+
+#define DSTAY_FOR_MONKEY 0x00000001	/* using monkey vnode */
+#define DSTAY_FOR_DEV	 0x00000002	/* mapping a device */
+#define DSTAY_FOR_86	 0x00000004	/* running in 86 mode */
+#define DSTAY_SYSTEM	0x00000008	/* system process (init, oM daemon) */
+#define DSTAY_FOR_PRIV	 0x00000010	/* privilleged inst. access (in/out) */
+#define DSTAY_FOR_MLOCK	 0x00000020	/* has locked memory */
+#define DSTAY_FOR_CLONE	 0x00000040	/* shared VM, eliminate this once DSM*/
+#define DSTAY_FOR_RT	 0x00000080	/* Real-Time scheduling */
+#define	DSTAY_FOR_IOPL	0x00000100	/* direct I/O permission */
+#define	DSTAY_FOR_KIOBUF 0x00000400	/* using kiobuf */
+#define	DSTAY_OTHER1	0x01000000	/* external reason for stay (1) */
+#define	DSTAY_OTHER2	0x02000000	/* external reason for stay (2) */
+#define	DSTAY_OTHER3	0x04000000	/* external reason for stay (3) */
+#define	DSTAY_OTHER4	0x08000000	/* external reason for stay (4) */
+#define DNOMIGRATE	0x80000000	/* user requested no auto-migrations */
+
+#define DSTAY   (~DNOMIGRATE)
+#define	DSTAY_PER_MM	(DSTAY_FOR_MONKEY|DSTAY_FOR_DEV|DSTAY_FOR_MLOCK|DSTAY_FOR_KIOBUF)
+
+/*
+ * where to go (whereto)
+ */
+#define GOBACKHOME	(-1)	/* just go back home */
+#define BALANCE		(-2)	/* perform load balancing */
+#define IOBALANCE	(-3)	/* perform load balancing for I/O */
+#define MEMBALANCE	(-4)	/* perform balancing for memory */
+#define	MFSBALANCE	(-5)	/* must go back home */
+#define	MUSTGOHOME	(-6)	/* must go back home */
+
+#define	evaluate_pending_signals_in_mosix_context() do { \
+	struct task_struct *p = current; \
+	unsigned long flags; \
+	spin_lock_irqsave(&p->sigmask_lock,flags);\
+	if(p->mosix.ignoreoldsigs) \
+		p->sigpending = (p->mosix.dflags & (DFAKESIGNAL|DHEAVYSLEEP)) == DFAKESIGNAL; \
+	else recalc_sigpending(p); \
+	spin_unlock_irqrestore(&p->sigmask_lock,flags); \
+	} while(0)
+
+#define	deeper_sleep() do { \
+	struct task_struct *p = current; \
+	if(!p->mosix.hsleep_count++) { \
+		unsigned long flags; \
+		spin_lock_irq(&runqueue_lock); \
+		p->mosix.dflags |= DHEAVYSLEEP; \
+		spin_unlock_irq(&runqueue_lock); \
+		spin_lock_irqsave(&p->sigmask_lock,flags); \
+		p->sigpending = 0; \
+		spin_unlock_irqrestore(&p->sigmask_lock,flags); \
+	} } while(0)
+
+#define	lighter_sleep() do { \
+	struct task_struct *p = current; \
+	if(!--p->mosix.hsleep_count) { \
+		spin_lock_irq(&runqueue_lock); \
+		p->mosix.dflags &= ~DHEAVYSLEEP; \
+		spin_unlock_irq(&runqueue_lock); \
+		evaluate_pending_signals_in_mosix_context(); \
+	} } while(0)
+
+#define	set_me_dumpable(on) do { \
+		if((on)) { \
+                   current->task_dumpable = (on); \
+                   if(current->mm) current->mm->dumpable = (on); \
+                   else current->mosix.dflags |= (DDUMPABLE|DTDUMPABLE); \
+                } else { \
+		   if(current->mm) current->mm->dumpable = (on); \
+                   else current->mosix.dflags &= ~(DDUMPABLE); \
+                } \
+	} while(0)
+
+#define	i_am_dumpable()	((current->mosix.dflags & DDEPUTY) ? \
+	((current->mosix.dflags & DDUMPABLE) != 0 && \
+        (current->mosix.dflags & DTDUMPABLE) != 0) : \
+	(current->task_dumpable && (current->mm ? current->mm->dumpable : 0)))
+
+/* dirty parameters: */
+/* sorry we are not allowed to add parameters to standard Linux routines */
+/* because they can be called by who knows what - even modules, so instead: */
+#define	MMAP_MMDOWNED		0x01	/* MM was downed prior to mmap() */
+#define	MMAP_MAYSHARE		0x02	/* ornament with VM_MAYSHARE */
+#define	MAPS_NOUSER		0x04	/* do not copy maps to user */
+#ifdef CONFIG_MOSIX_FS
+#define	MFSARG_OLDREADDIR	0x08	/* this is "old_readdir" calling */
+#define	MFSARG_GETDENTS		0x10	/* this is "getdents" calling */
+#define	MFSARG_GETDENTS64	0x20	/* this is "getdents" calling */
+#define	MFSARG_EMPTYF_PRI	0x40	/* obtain empty file even beyond limit*/
+#define	MFSARG_RONLY		0x80	/* no write-permission on anything */
+#define MFSARG_STATFS_FP        0x100   /* pointer to file for statsfs */
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+#define	FILP_OPEN_SYSCALL	0x200	/* filp_open called from sys_open */
+#endif /* CONFIG_MOSIX_DFSA */
+
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/hpcversion.h linux-openmosix/include/hpc/hpcversion.h
--- linux/include/hpc/hpcversion.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/hpcversion.h	2004-05-23 15:39:46.000000000 +0200
@@ -0,0 +1,24 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s):  Moshe Bar, Amnon Shiloh, Oren Laadan.
+ */
+
+#ifndef _MOS_VERSION_H
+#define _MOS_VERSION_H
+
+/* The following are the EXTERNAL openMosix versions, used to enforce compatibility
+ * between different openMosix nodes when migrating and exchanging information -
+ * as opposed to the later INTERNAL kernel version, being used for reference
+ */
+#define MOSIX_MIGRATION_VERSION	0x000054L /* in 2.4.24 af of 2004523 */
+#define MOSIX_BALANCE_VERSION	0x000041L /* " */
+
+#define MOSIX_KERNEL_VERSION	 10904	/* version 1.9.2 */
+
+#define MOSIX_VERSION_PARTS(x) (x)/10000, ((x)%10000)/100, (x)%100
+	
+#endif /* _MOS_VERSION_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/mfscosts.h linux-openmosix/include/hpc/mfscosts.h
--- linux/include/hpc/mfscosts.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/mfscosts.h	2002-06-24 09:22:32.000000000 +0200
@@ -0,0 +1,14 @@
+/* mfscosts.h -- MOSIX */
+/* cost of MFS operations (microseconds) */
+
+/* measuring date: Mon Apr 30 20:12:28 IDT 2001 */
+/* between two Pentium-III/1GHz over Ethernet-100 */
+
+#define MFS_COST_CONN_S 36
+#define MFS_COST_CONN_C 40
+
+#define MFS_COST_INKB_S 14
+#define MFS_COST_INKB_C 19
+
+#define MFS_COST_OUTKB_S 88
+#define MFS_COST_OUTKB_C 56
